VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBC WIC Codec"
   ClientHeight    =   7005
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   12000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   467
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   800
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtWicInfo 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2085
      Left            =   30
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   30
      Width           =   3525
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler
' Datum: 08/2020

Option Explicit

Private Const WM_SETTEXT As Long = &HC&

Private Declare Function SendMessageW Lib "user32" ( _
                         ByVal hwnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         ByRef lParam As Any) As Long

Private Sub Form_Load()
    
    Dim lItem As Long
    Dim lCount As Long
    Dim sRet As String
    Dim pIWicFactory As Long
    Dim pIWICBitmapCodecInfo As Long
    Dim pIEnumUnknown As Long
    Dim pIUnknown(0) As Long
    Dim tGUID() As GUID

    Me.ScaleMode = vbPixels
    txtWicInfo.Move 3, 3, Me.ScaleWidth - 6, Me.ScaleHeight - 6

    ' WIC-Factory erstellen -> pIWicFactory
    If CreateInterface(CLSID_WICImagingFactory1, IID_IWICImagingFactory, pIWicFactory) = True Then
    
        ' ComponentEnumerator erstellen -> pIEnumUnknown
        If Invoke(pIWicFactory, CreateComponentEnumerator, WICComponentType.WICDecoder Or _
            WICComponentType.WICEncoder, WICComponentEnumerateOptions.WICComponentEnumerateDefault, _
            VarPtr(pIEnumUnknown)) = S_OK Then
        
            ' alle Items in pIEnumUnknown durchlaufen (jeweils nur ein Item lesen) -> pIUnknown
            Do While Invoke(pIEnumUnknown, Fetch, UBound(pIUnknown) + 1&, _
                VarPtr(pIUnknown(0)), 0&) = S_OK
            
                ' IWICBitmapCodecInfo erstellen - pIWICBitmapCodecInfo
                If Invoke(pIUnknown(0), QueryInterface, VarPtr(Str2Guid(IID_IWICBitmapCodecInfo)), _
                    VarPtr(pIWICBitmapCodecInfo)) = S_OK Then
                    
                    ' entsprechende Infos auslesen
                    sRet = sRet & "========================================================================================" & vbNewLine
                    sRet = sRet & "Author: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetAuthor) & vbNewLine
                    sRet = sRet & "FriendlyName: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetFriendlyName) & vbNewLine
                    sRet = sRet & "FileExtensions: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetFileExtensions) & vbNewLine
                    sRet = sRet & "MimeTypes: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetMimeTypes) & vbNewLine
                    sRet = sRet & "DeviceModels: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetDeviceModels) & vbNewLine
                    sRet = sRet & "DeviceManufacturer: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetDeviceManufacturer) & vbNewLine
                    sRet = sRet & "ComponentType: " & CStr(GetCodecInfoLong(pIWICBitmapCodecInfo, GetComponentType)) & vbNewLine
                    sRet = sRet & "SigningStatus: " & CStr(GetCodecInfoLong(pIWICBitmapCodecInfo, GetSigningStatus)) & vbNewLine
                    sRet = sRet & "Version: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetVersion) & vbNewLine
                    sRet = sRet & "SpecVersion: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetSpecVersion) & vbNewLine
                    sRet = sRet & "ColorManagementVersion: " & GetCodecInfoString(pIWICBitmapCodecInfo, GetColorManagementVersion) & vbNewLine
                    
                    sRet = sRet & "CLSID: " & Clsid2Str(GetCodecInfoCLSID(pIWICBitmapCodecInfo, GetCLSID)) & vbNewLine
                    sRet = sRet & "VendorGUID: " & Guid2Str(GetCodecInfoGUID(pIWICBitmapCodecInfo, GetVendorGUID)) & vbNewLine
                    sRet = sRet & "ContainerFormat: " & Guid2Str(GetCodecInfoGUID(pIWICBitmapCodecInfo, GetContainerFormat)) & vbNewLine
                    
                    sRet = sRet & "*********** Supported Pixelformats ***********" & vbNewLine
                    tGUID = GetCodecInfoGUID_ARRAY(pIWICBitmapCodecInfo, GetPixelFormats)
                    lCount = UBound(tGUID)
                    For lItem = 0 To lCount
                        sRet = sRet & vbTab & Guid2Str(tGUID(lItem)) & vbNewLine
                    Next
                    sRet = sRet & "**********************************************" & vbNewLine
                    
                    sRet = sRet & "SupportAnimation: " & CStr(GetCodecInfoBool(pIWICBitmapCodecInfo, DoesSupportAnimation)) & vbNewLine
                    sRet = sRet & "SupportChromaKey: " & CStr(GetCodecInfoBool(pIWICBitmapCodecInfo, DoesSupportChromaKey)) & vbNewLine
                    sRet = sRet & "SupportLossless: " & CStr(GetCodecInfoBool(pIWICBitmapCodecInfo, DoesSupportLossless)) & vbNewLine
                    sRet = sRet & "SupportMultiframe: " & CStr(GetCodecInfoBool(pIWICBitmapCodecInfo, DoesSupportMultiframe)) & vbNewLine
                    sRet = sRet & "========================================================================================" & vbNewLine
                    
                    sRet = sRet & vbNewLine
                    
                    ' pIWICBitmapCodecInfo freigeben
                    Call ReleaseInterface(pIWICBitmapCodecInfo)
                
                End If
            
                ' pIUnknown freigeben
                Call ReleaseInterface(pIUnknown(0))
            
            Loop
            
            ' pIEnumUnknown freigeben
            Call ReleaseInterface(pIEnumUnknown)
        
        End If

        ' pIWicFactory freigeben
        Call ReleaseInterface(pIWicFactory)
    
    End If
    
    ' sRet in die Textbox (per API falls sRet > 64k)
    Call SendMessageW(txtWicInfo.hwnd, WM_SETTEXT, 0&, ByVal StrPtr(sRet))
    
End Sub
